diff --exclude CVS -ur u-boot-cvs/common/dlmalloc.c u-boot/common/dlmalloc.c
--- u-boot-cvs/common/dlmalloc.c	2003-06-27 17:32:31.000000000 -0400
+++ u-boot/common/dlmalloc.c	2004-02-16 22:05:41.000000000 -0500
@@ -936,7 +936,7 @@
 #else				/* Moved to malloc.h */
 
 #include <malloc.h>
-#if 0
+#ifdef DEBUG
 #if __STD_C
 static void malloc_update_mallinfo (void);
 void malloc_stats (void);
@@ -1589,7 +1589,7 @@
 
 /* Tracking mmaps */
 
-#if 0
+#ifdef DEBUG
 static unsigned int n_mmaps = 0;
 #endif	/* 0 */
 static unsigned long mmapped_mem = 0;
@@ -3066,7 +3066,7 @@
 
 /* Utility to update current_mallinfo for malloc_stats and mallinfo() */
 
-#if 0
+#ifdef DEBUG
 static void malloc_update_mallinfo()
 {
   int i;
@@ -3123,7 +3123,7 @@
 
 */
 
-#if 0
+#ifdef DEBUG
 void malloc_stats()
 {
   malloc_update_mallinfo();
@@ -3144,7 +3144,7 @@
   mallinfo returns a copy of updated current mallinfo.
 */
 
-#if 0
+#ifdef DEBUG
 struct mallinfo mALLINFo()
 {
   malloc_update_mallinfo();
diff --exclude CVS -ur u-boot-cvs/drivers/cfi_flash.c u-boot/drivers/cfi_flash.c
--- u-boot-cvs/drivers/cfi_flash.c	2004-02-11 19:47:14.000000000 -0500
+++ u-boot/drivers/cfi_flash.c	2004-02-16 20:17:56.000000000 -0500
@@ -45,7 +45,9 @@
 #undef	DEBUG
 #include <common.h>
 #include <asm/processor.h>
+#include <linux/byteorder/swab.h>
 #ifdef	CFG_FLASH_CFI_DRIVER
+
 /*
  * This file implements a Common Flash Interface (CFI) driver for U-Boot.
  * The width of the port and the width of the chips are determined at initialization.
@@ -761,16 +763,29 @@
 	int i;
 
 #if defined(__LITTLE_ENDIAN)
-	ushort stmp;
+	ushort stmpw;
+	uint   stmpi;
 #endif
 	uchar *cp = (uchar *) cmdbuf;
 
 	for (i = 0; i < info->portwidth; i++)
 		*cp++ = ((i + 1) % info->chipwidth) ? '\0' : cmd;
 #if defined(__LITTLE_ENDIAN)
-	if (info->portwidth == 2) {
-		stmp = *(ushort *) cmdbuf;
-		*(ushort *) cmdbuf = swab16 (stmp);
+	switch (info->portwidth)
+	{
+		case FLASH_CFI_8BIT:
+			break;
+		case FLASH_CFI_16BIT:
+			stmpw = *(ushort *) cmdbuf;
+			*(ushort *) cmdbuf = __swab16 (stmpw);
+			break;
+		case FLASH_CFI_32BIT:
+			stmpi = *(uint *) cmdbuf;
+			*(uint *) cmdbuf = __swab32 (stmpi);
+			break;
+		default:
+			printf("WARNING: flash_make_cmd: unsuppport LittleEndian mode\n");
+			break;
 	}
 #endif
 }
